/***************************************************************************
                           channelimportdlgimpl.cpp
                           ------------------------
    begin                : Sat Oct 25 2003
    copyright            : (C) 2003 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
    rcs data             : $Id: channelimportdlgimpl.cpp,v 1.1 2003/10/25 18:03:14 dziegel Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kdebug.h>
#include <klocale.h>
#include <qcombobox.h>
#include <qpushbutton.h>

#include <kconfig.h>
#include <kmessagebox.h>

#include "qtvision.h"
#include "sourcemanager.h"
#include "qvsrcplugin.h"
#include "channel.h"
#include "channelstore.h"
#include "channelimporter.h"
#include "channelimportdlgimpl.h"

ChannelImportDlgImpl::ChannelImportDlgImpl(QtVision* qtv, QWidget* parent, const char* name, bool modal, WFlags flags)
    : ChannelImportDlg(parent, name, modal, flags),
      _qtv(qtv)
{
    _importer = new ChannelImporter();
    _freqList->insertStringList(_importer->lists());
    
    _source->insertStringList(_qtv->sourceManager()->sourcesFor(_qtv->device()->device()));
    QString st = _qtv->device()->source();
    for (int i = 0; i < _source->count(); i++) {
	if (_source->text(i) == st) {
	    _source->setCurrentItem(i);
	    break;
	}
    }

    _encoding->insertStringList(_qtv->sourceManager()->encodingsFor(_qtv->device()->device()));
    QString et = _qtv->device()->encoding();
    for (int i = 0; i < _encoding->count(); i++) {
	if (_encoding->text(i) == et) {
	    _encoding->setCurrentItem(i);
	    break;
	}
    }
}

ChannelImportDlgImpl::~ChannelImportDlgImpl()
{
    delete _importer;
}

void ChannelImportDlgImpl::accept()
{
    int rc = KMessageBox::warningContinueCancel(0L,
						i18n("Are you sure you want to import?\nThis will overwrite your current channel file!"),
						i18n("Continue import?"));

    if (rc == KMessageBox::Cancel) {
	reject();
	return;
    }

    ChannelStore* cs = _qtv->channels();
    cs->clear();
    _importer->import(cs, _freqList->currentText());

    for (uint i=0; i<cs->count(); i++) {
	Channel* c = cs->channelAt(i);

	c->setSource(_source->currentText());
	c->setEncoding(_encoding->currentText());
    }

    _qtv->setChannel(1);
    QDialog::accept();
}

#include "channelimportdlgimpl.moc"
