/***************************************************************************
                           channelimporter.cpp
                           -------------------
    begin                : Sat Oct 25 2003
    copyright            : (C) 2003 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
    rcs data             : $Id: channelimporter.cpp,v 1.1 2003/10/25 18:03:14 dziegel Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kdebug.h>
#include <klocale.h>
#include <kglobal.h>
#include <kstandarddirs.h>
#include <kconfig.h>

#include <qstringlist.h>
#include <qdir.h>

#include "channelstore.h"
#include "channelimporter.h"

ChannelImporter::ChannelImporter()
    : _map(0L)
{
    QStringList qsl = KGlobal::dirs()->resourceDirs("qtvision");
    for (QStringList::Iterator p = qsl.begin(); p != qsl.end(); ++p) {
	_path = *p + "channels-dist/";
	if (QDir(_path).exists()) {
	    _map = new KConfig(_path + "Index.map", true, false);
	    break;
	}
    }   
}

ChannelImporter::~ChannelImporter()
{
    if (_map) delete _map;
}

QStringList ChannelImporter::lists()
{
    if (!_map) return QStringList();
    return _map->groupList();
}

bool ChannelImporter::import(ChannelStore* store, const QString& list)
{
    if (!_map) return false;

    _map->setGroup(list);
    QString name = _map->readEntry("file", QString::null);
    if (name.isEmpty()) {
	kdDebug() << "Error reading frequency list map file. Check your installation!" << endl;
	return false;
    }
    
    if (!store->load(_path + name, "xawtv")) {
	kdDebug() << "Error importing frequency list file. Check your installation!" << endl;
	return false;
    }

    store->renumber();
    return true;
}


#include "channelimporter.moc"
