// -*- c++ -*-
/***************************************************************************
                           channelimporter.h
                           -----------------
    begin                : Sat Oct 25 2003
    copyright            : (C) 2003 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
    rcs data             : $Id: channelimporter.h,v 1.1 2003/10/25 18:03:14 dziegel Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHANNELIMPORTER_H
#define CHANNELIMPORTER_H

#include <qobject.h>
#include <qstring.h>

class ChannelStore;
class QStringList;
class KConfig;

/**
 * Imports default channel lists
 * @author Dirk Ziegelmeier <dziegel@gmx.de>
 */
class ChannelImporter : public QObject
{
    Q_OBJECT
	
public: 
    ChannelImporter();
    virtual ~ChannelImporter();

    /// Returns available channel lists
    QStringList lists();

    /// imports desired list to store
    bool import(ChannelStore*, const QString& list);


private:
    KConfig* _map;
    QString  _path;
};

#endif
