// -*- c++ -*-
/***************************************************************************
                           channelscanner.h
                           ----------------
    begin                : Sat Oct 25 2003
    copyright            : (C) 2003 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
    rcs data             : $Id: channelscanner.h,v 1.7 2003/10/26 15:33:31 dziegel Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHANNELSCANNER_H
#define CHANNELSCANNER_H

#include <qstring.h>
#include "chwizard.h"

class QtVision;
class Channel;
class QVSourcePlugin;
class ScannerFrequencyFactory;
class ChannelStore;
class ChannelImporter;
class VbiDecoder;

class ChannelScanner : public ChWizard
{
    Q_OBJECT


public:
    ChannelScanner( QtVision*, QWidget* parent=0, const char* name=0 );
    virtual ~ChannelScanner();


signals:
    void progress(int);
    void stationFound(Channel*);


private slots:
    void pageChanged();
    void updatePageSelection();
    void checkSignalStrengthReadback();
    void cancelClicked();
    void finished();
    void updateSource();
    void updateEncoding();


private:
    enum {
	Setup=0, prepareFreqRange, preparePredefined, Scanning, Finished
    } wizardPages;

    bool scan();
    bool isStation();
    void setupFinishedPage();
    void doScan();
    ulong fineTune(ulong freq);

    VbiDecoder*              _vbiDecoder;
    ScannerFrequencyFactory* _freqFactory;
    ChannelStore*            _store;

    bool             _cancel;
    int              _vbiFd;

    ChannelImporter* _channelImporter;
    QtVision*        _qtv;
    QVSourcePlugin*  _videoDev;
};

#endif // CHANNELSCANNER_H
