// -*- c++ -*-

/*
 * Copyright (C) 2002 Richard Moore <rich@kde.org>
 *               2003 Dirk Ziegelmeier <dziegel@gmx.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef SCREENSAVER_H
#define SCREENSAVER_H

#include <kscreensaver.h>
#include <kdialogbase.h>

class QtVisionWidget;

class QtVisionSaver : public KScreenSaver
{
    Q_OBJECT

public:
    QtVisionSaver( WId drawable );
    virtual ~QtVisionSaver();

protected slots:
    void applySettings();

protected:
    QtVisionWidget* _screen;
};

class QtVisionSaverSetup : public KDialogBase
{
public:
    QtVisionSaverSetup( QWidget *parent, const char *name );
    virtual ~QtVisionSaverSetup();

    void slotOk();

private:
    QGridLayout* _grid;

    QLabel*      _channelLabel;
    QSpinBox*    _channelSpinbox;

    QLabel*      _volumeLabel;
    QSpinBox*    _volumeSpinbox;

    QLabel*      _infoLabel;
};

#endif // SCREENSAVER_H




