/***************************************************************************
                          devicewidgetimpl.h  -  description
                             -------------------
    begin                : Mon Jun 3 2002
    copyright            : (C) 2002 by Kevin Hessels
    email                : khessels@shaw.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DEVICEWIDGETIMPL_H
#define DEVICEWIDGETIMPL_H

#include <devicewidget.h>

#include "pluginfactory.h"
#include "settingsdialogpage.h"

class ConfigData;
class QtVision;
class SourceManager;


/**
 * @author Kevin Hessels and Dirk Ziegelmeier
 */

class DeviceWidgetImpl : public DeviceWidget, public SettingsDialogPage
{
    Q_OBJECT

public: 
    DeviceWidgetImpl(QWidget *, QtVision *, ConfigData*, KConfig*);
    ~DeviceWidgetImpl();

    /** set QtVision object to contain the currently selected device */
    void device(QtVision *);
    /** Update the dialog to display the currently selected device, if it exists */
    void setCurrentDevice();

    virtual void setup();
    virtual void apply();
    virtual void defaults();


protected slots:
    void slotChangeSources(const QString &);


private:
    QtVision*      _qtv;
    SourceManager* _srcm;
    ConfigData*    _cfg;
    KConfig*       _h;
};

#endif
