// -*- c++ -*-
/***************************************************************************
                           generalwidgetimpl.h
                           -------------------
    begin                : Sun Sep 6 2003
    copyright            : (C) 2003 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
    rcs data             : $Id: generalwidgetimpl.h,v 1.4 2003/10/22 10:32:31 dziegel Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GENERALWIDGETIMPL_H
#define GENERALWIDGETIMPL_H

#include "generalwidget.h"
#include "settingsdialogpage.h"

/**
 * @author Dirk Ziegelmeier <dziegel@gmx.de>
 */

class QListViewItem;
class QtVision;
class SourceManager;
class ConfigData;
class KConfig;

class GeneralWidgetImpl : public GeneralWidget, public SettingsDialogPage
{
    Q_OBJECT
	
 public: 
    GeneralWidgetImpl(QWidget*, QtVision*, ConfigData*, KConfig*);
    ~GeneralWidgetImpl();
    
    virtual void setup();
    virtual void apply();
    virtual void defaults();


 private slots:
    void slotEditClicked();
    void slotSelectionChanged();


 private:
    QtVision*              _qtv;
    SourceManager*         _srcm;
    ConfigData*            _cfg;
    KConfig*               _h;
};

#endif
