// -*- c++ -*-
/***************************************************************************
                           picturewidgetimpl.h
                           -------------------
    begin                : Sun Sep 6 2003
    copyright            : (C) 2003 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
    rcs data             : $Id: picturewidgetimpl.h,v 1.2 2003/10/20 08:21:10 dziegel Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PICTUREWIDGETIMPL_H
#define PICTUREWIDGETIMPL_H

#include "picturewidget.h"
#include "settingsdialogpage.h"

class QtVision;
class ConfigData;
class KConfig;

/**
 * @author Dirk Ziegelmeier <dziegel@gmx.de>
 */

class PictureWidgetImpl : public PictureWidget, public SettingsDialogPage
{
    Q_OBJECT
    
public: 
    PictureWidgetImpl(QWidget*, QtVision*, ConfigData*, KConfig*);
    ~PictureWidgetImpl();
    
    virtual void setup();
    virtual void apply();
    virtual void defaults();
    virtual void cancel();


private slots:
    void slotHueChanged(int);
    void slotColourChanged(int);
    void slotBrightnessChanged(int);
    void slotWhitenessChanged(int);
    void slotContrastChanged(int);


private:
    QtVision* _qtv;
    ConfigData* _cfg;
    KConfig* _h;

    int _oldHue;
    int _oldColour;
    int _oldBrightness;
    int _oldWhiteness;
    int _oldContrast;
};

#endif
