// -*- c++ -*-
/***************************************************************************
                          pluginwidgetimpl.h  -  description
                             -------------------
    begin                : Sat Jun 8 2002
    copyright            : (C) 2002 by Kevin Hessels
    email                : khessels@shaw.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLUGINWIDGETIMPL_H
#define PLUGINWIDGETIMPL_H

#include <qtabwidget.h>
#include "pluginfactory.h"
#include "pluginwidget.h"
#include "settingsdialogpage.h"

class QtVision;
class ConfigData;
class KConfig;

/**
 * @author Kevin Hessels, George Staikos, Dirk Ziegelmeier
 */

class PluginWidgetImpl : public PluginWidget, public SettingsDialogPage
{
    Q_OBJECT
    
    
public: 
    PluginWidgetImpl(QWidget*, QtVision*, ConfigData*, KConfig*);
    ~PluginWidgetImpl();

    virtual void setup();
    virtual void apply();
    virtual void defaults();


private slots:
    void slotConfigurePlugin();
    void slotSelectionChanged();


private:
    QtVision*   _qtv;
    ConfigData* _cfg;
    KConfig*    _h;
};

#endif
