// -*- c++ -*-
/***************************************************************************
                          settingsdialog.h  -  description
                             -------------------
    begin                : Sat May 11 2002
    copyright            : (C) 2002 by Kevin Hessels, (C) 2003 Dirk Ziegelmeier
    email                : khessels@shaw.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H

#include <kdialogbase.h>
#include <qptrlist.h>

class ConfigData;
class KConfig;
class QtVision;
class SettingsDialogPage;

/**
 * @author Kevin Hessels
 */
class SettingsDialog : public KDialogBase
{
    Q_OBJECT

public:
    SettingsDialog(QWidget*, char*, bool, QtVision*, QPtrList<SettingsDialogPage>*);
    ~SettingsDialog();
    

signals:
    void optionsModified();


protected slots:
    void slotApply();
    void slotDefault();
    void slotCancel();
    void slotOk();
    void slotHelp();


private:
    void doApply();
    void addDialogPage(SettingsDialogPage* page);

    QtVision*                    _qtv;
    QPtrList<SettingsDialogPage> _pages;
    int                          _externalPageCount;
};

#endif

