// -*- c++ -*-
/***************************************************************************
                           soundwidgetimpl.h
                           -------------------
    begin                : Sun Sep 6 2003
    copyright            : (C) 2003 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
    rcs data             : $Id: soundwidgetimpl.h,v 1.3 2003/10/20 08:21:10 dziegel Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SOUNDWIDGETIMPL_H
#define SOUNDWIDGETIMPL_H

#include "soundwidget.h"
#include "pluginfactory.h"
#include "settingsdialogpage.h"

class ConfigData;
class KConfig;
class QtVision;

/**
 * @author Dirk Ziegelmeier <dziegel@gmx.de>
 */

class SoundWidgetImpl : public SoundWidget, public SettingsDialogPage
{
    Q_OBJECT
	
public: 
    SoundWidgetImpl(QWidget*, QtVision*, ConfigData*, KConfig*);
    ~SoundWidgetImpl();

    virtual void setup();
    virtual void apply();
    virtual void defaults();

    
private slots:
    void mixerSelectionChanged(const QString& mixer);
    void configurePlugin();
    

private:
    PluginDesc* getPluginDesc(const QString& mixer);

    QString     _prevMixer;
    QtVision*   _qtv;
    ConfigData* _cfg;
    KConfig*    _h;
};
#endif
