/***************************************************************************
                           vbidecoder.h
                           ------------
    begin                : Sun Oct 26 2003
    copyright            : (C) 2003 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
    rcs data             : $Id: vbidecoder.h,v 1.1 2003/10/26 11:42:48 dziegel Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VBIDECODER_H
#define VBIDECODER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qthread.h>
#include <qstring.h>

#ifdef HAVE_ZVBI
#include <libzvbi.h>
#include <qmutex.h>

class VbiDecoder : public QThread
{
public:
    VbiDecoder();
    virtual ~VbiDecoder();

    bool    init(const QString& dev);
    void    stop();
    int     vbiHandle();
    QString stationName();

    // for internal use
    void vbiEvent(vbi_event* event);

protected:
    virtual void run();


private:
    QMutex  _eventMutex;

    QString _stationName;

    bool             _terminate;
    vbi_decoder*     _dec;
    vbi_capture*     _cap;
    vbi_raw_decoder* _par;
    vbi_sliced*      _sliced;
};

#else // HAVE_ZVBI

class VbiDecoder : public QThread
{
public:
    VbiDecoder() {}
    virtual ~VbiDecoder() {}

    bool    init(const QString&) {return false;}
    void    stop() {}
    int     vbiHandle() {return -1;}
    QString stationName() {return QString::null;}

protected:
    virtual void run() {}
};
#endif // HAVE_ZVBI


#endif // VBIDECODER_H
