// -*- c++ -*-
/***************************************************************************
                           videowidgetimpl.h
                           -------------------
    begin                : Sun Sep 6 2003
    copyright            : (C) 2003 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
    rcs data             : $Id: videowidgetimpl.h,v 1.3 2003/10/20 08:21:10 dziegel Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VIDEOWIDGETIMPL_H
#define VIDEOWIDGETIMPL_H

#include "videowidget.h"
#include "pluginfactory.h"
#include "settingsdialogpage.h"

class ConfigData;
class QtVision;

/**
 * @author Dirk Ziegelmeier <dziegel@gmx.de>
 */

class VideoWidgetImpl : public VideoWidget, public SettingsDialogPage
{
    Q_OBJECT
	
 public: 
    VideoWidgetImpl(QWidget*, QtVision*, ConfigData*, KConfig*);
    ~VideoWidgetImpl();
    
    virtual void setup();
    virtual void apply();
    virtual void defaults();

    
 private slots:
    void selectionChanged();
    void configurePlugin();
    void itemDoubleClicked(QListViewItem*);


 private:
    QtVision*   _qtv;
    ConfigData* _cfg;
    KConfig*    _h;
};

#endif
